float4x4 WVP : WorldViewProjection;

texture MyTexture <
    string ResourceName = "texture.dds";
>;

sampler MySampler = sampler_state {
    texture = <MyTexture>;
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};

struct AppData {
    float3 position : POSITION;
    float2 uv : TEXCOORD0;
};

struct VertexOutput {
    float4 hPosition : POSITION;
    float2 uv : TEXCOORD0;
};

struct PixelOutput {
    float4 color : COLOR;
};

VertexOutput VS_Texture(AppData IN) {
    VertexOutput OUT;
    OUT.hPosition = mul(float4(IN.position, 1.0), WVP);
    OUT.uv = IN.uv;
    return OUT;
}

PixelOutput PS_Texture(VertexOutput IN) {
    PixelOutput OUT;
    OUT.color = tex2D(MySampler, IN.uv);
    return OUT;
}

technique textureTechnique {
    pass p0 {
        VertexShader = compile vs_2_0 VS_Texture();
        PixelShader  = compile ps_2_0 PS_Texture();
    }
}